<?php

namespace FiloBlu\GcpLogging\Logger;

use FiloBlu\GcpLogging\Helper\Data;

class Logger extends \Monolog\Logger
{
    /**
     * @var Data
     */
    private $data;

    public function __construct(
        $name,
        array $handlers = array(),
        array $processors = array(),
        Data $data
    )
    {
        parent::__construct($name, $handlers, $processors);
        $this->data = $data;
    }

    public function addRecord($level, $message, array $context = array())
    {
        $handlers = $this->getHandlers();
        $logType = $this->data->getGcpLoggingType();
        foreach ($handlers as $key => $val) {
            if(get_class($val) != $logType) {
                unset($handlers[$key]);
            }
        }
        $this->setHandlers($handlers);

        $contextData = [
            'client_log' => $context
        ];

        $contextData['module'] = $this->data->moduleName();
        $contextData['site'] = $this->data->getBackEndUrl();
        $contextData['stack_trace'] = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS, 20);

        $context = $contextData;

        return parent::addRecord($level, $message, $context);
    }
}
